#include <bits/stdc++.h>
using namespace std;

int h, w;
string grid[1024];
int sx, sy;

struct pos {
    int x, y, dx, dy;
    bool operator <(pos oth) const {
        return x < oth.x || x == oth.x && y < oth.y || x == oth.x && y == oth.y && dx < oth.dx || x == oth.x && y == oth.y && dx == oth.dx && dy < oth.dy;
    }
};
map<pos, pair<int, pos>> mp;

pos finish;
bool found;

queue<pos> bfs (queue<pos> q) {
    vector<pos> diag;
    queue<pos> res;
    while (!q.empty()) {
        pos p = q.front();
        if (p.x == -1 || p.x == h || p.y == -1 || p.y == w) {
            finish = p;
            found = 1;
            return res;
        }
        q.pop();
        pos nxt;
        if (grid[p.x][p.y] == '.' || grid[p.x][p.y] == 'S') nxt = {p.x + p.dx, p.y + p.dy, p.dx, p.dy};
        else if (grid[p.x][p.y] == '#') nxt = {p.x - p.dx, p.y - p.dy, -p.dx, -p.dy};
        else if (grid[p.x][p.y] == '/') {
            nxt = {p.x - p.dy, p.y - p.dx, -p.dy, -p.dx};
            diag.push_back(p);
        }
        else {
            nxt = {p.x + p.dy, p.y + p.dx, p.dy, p.dx};
            diag.push_back(p);
        }
        if (mp.find(nxt) == mp.end()) {
            mp[nxt] = mp[p];
            q.push(nxt);
        }
    }
    for (pos p : diag) {
        pos nxt = {p.x + p.dx, p.y + p.dy, p.dx, p.dy};
        if (mp.find(nxt) == mp.end()) {
            mp[nxt] = {mp[p].first + 1, p};
            res.push(nxt);
        }
        if (grid[p.x][p.y] == '/') nxt = {p.x + p.dy, p.y + p.dx, p.dy, p.dx};
        else nxt = {p.x - p.dy, p.y - p.dx, -p.dy, -p.dx};
        if (mp.find(nxt) == mp.end()) {
            mp[nxt] = {mp[p].first + 1, p};
            res.push(nxt);
        }
    }
    return res;
}

struct del {
    int t, x, y;
};

int main() {

    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> h >> w;
    for (int i = 0; i < h; i++) {
        cin >> grid[i];
        for (int j = 0; j < w; j++) {
            if (grid[i][j] == 'S') {
                sx = i;
                sy = j;
            }
        }
    }

    queue<pos> q;
    q.push({sx, sy, 1, 0});
    mp[{sx, sy, 1, 0}] = {0, {sx, sy, 1, 0}};
    q.push({sx, sy, -1, 0});
    mp[{sx, sy, -1, 0}] = {0, {sx, sy, -1, 0}};
    q.push({sx, sy, 0, 1});
    mp[{sx, sy, 0, 1}] = {0, {sx, sy, 0, 1}};
    q.push({sx, sy, 0, -1});
    mp[{sx, sy, 0, -1}] = {0, {sx, sy, 0, -1}};

    while (!found && !q.empty()) {
        q = bfs(q);
    }

    if (!found) {
        cout << "NO\n";
        return 0;
    }

    cout << "YES\n";
    int cnt = mp[finish].first;
    for (pos p = mp[finish].second; p.x != sx || p.y != sy; p = mp[p].second) {
        if (grid[p.x][p.y] == '/') grid[p.x][p.y] = 'D';
        else grid[p.x][p.y] = 'd';
    }

    int t = 0;
    pos p = finish;
    vector<del> res;
    while (p.x != sx || p.y != sy) {
        pos nxt;
        if ((p.x == finish.x && p.y == finish.y)) nxt = {p.x - p.dx, p.y - p.dy, p.dx, p.dy};
        else if (grid[p.x][p.y] == '.' || grid[p.x][p.y] == 'D' || grid[p.x][p.y] == 'd') {
            nxt = {p.x - p.dx, p.y - p.dy, p.dx, p.dy};
            if (grid[p.x][p.y] == 'D') {
                grid[p.x][p.y] = '/';
                res.push_back({t, p.x, p.y});
            }
            else if (grid[p.x][p.y] == 'd') {
                grid[p.x][p.y] = '\\';
                res.push_back({t, p.x, p.y});
            }
        }
        else if (grid[p.x][p.y] == '#') nxt = {p.x + p.dx, p.y + p.dy, -p.dx, -p.dy}, t--;
        else if (grid[p.x][p.y] == '/') nxt = {p.x + p.dy, p.y + p.dx, -p.dy, -p.dx};
        else nxt = {p.x - p.dy, p.y - p.dx, p.dy, p.dx};
        
        t ++;
        p = nxt;
    }

    if (p.dx == 1) cout << "D\n";
    else if (p.dx == -1) cout << "U\n";
    else if (p.dy == 1) cout << "R\n";
    else cout << "L\n";

    cout << res.size() << '\n';
    reverse(res.begin(), res.end());
    for (del d : res) {
        cout << t - d.t << ' ' << d.x + 1 << ' ' << d.y + 1 << '\n';
    }

}